diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/three-gpp-channel-model.cc ns-3.36/src/spectrum/model/three-gpp-channel-model.cc
--- ns-3.35/src/spectrum/model/three-gpp-channel-model.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/three-gpp-channel-model.cc	2022-04-30 18:23:58.146735000 -0700
@@ -1199,147 +1338,139 @@
     }
 
   //remove clusters with less than -25 dB power compared to the maxim cluster power;
-  //double thresh = pow(10,-2.5);
+  //double thresh = pow(10, -2.5);
   double thresh = 0.0032;
-  for (uint8_t cIndex = numOfCluster; cIndex > 0; cIndex--)
+  for (uint8_t cIndex = table3gpp->m_numOfCluster; cIndex > 0; cIndex--)
     {
       if (clusterPowerForAngles[cIndex - 1] < thresh * powerMax )
         {
           clusterPowerForAngles.erase (clusterPowerForAngles.begin () + cIndex - 1);
-          clusterPower.erase (clusterPower.begin () + cIndex - 1);
+          channelParams->m_clusterPower.erase (channelParams->m_clusterPower.begin () + cIndex - 1);
           clusterDelay.erase (clusterDelay.begin () + cIndex - 1);
         }
     }
 
-  NS_ASSERT (clusterPower.size () < UINT8_MAX);
-  uint8_t numReducedCluster = clusterPower.size ();
-
-  channelParams->m_numCluster = numReducedCluster;
+  NS_ASSERT (channelParams->m_clusterPower.size () < UINT8_MAX);
+  channelParams->m_reducedClusterNumber = channelParams->m_clusterPower.size ();
   // Resume step 5 to compute the delay for LoS condition.
-  if (los)
+  if (channelParams->m_losCondition == ChannelCondition::LOS)
     {
-      double C_tau = 0.7705 - 0.0433 * K_factor + 2e-4 * pow (K_factor,2) + 17e-6 * pow (K_factor,3);         //(7.5-3)
-      for (uint8_t cIndex = 0; cIndex < numReducedCluster; cIndex++)
+      double cTau = 0.7705 - 0.0433 * kFactor + 2e-4 * pow (kFactor,2) + 17e-6 * pow (kFactor,3);         //(7.5-3)
+      for (uint8_t cIndex = 0; cIndex < channelParams->m_reducedClusterNumber; cIndex++)
         {
-          clusterDelay[cIndex] = clusterDelay[cIndex] / C_tau;             //(7.5-4)
+          clusterDelay[cIndex] = clusterDelay[cIndex] / cTau; //(7.5-4)
         }
     }
 
   //Step 7: Generate arrival and departure angles for both azimuth and elevation.
 
-  double C_NLOS, C_phi;
+  double cNlos;
   //According to table 7.5-6, only cluster number equals to 8, 10, 11, 12, 19 and 20 is valid.
   //Not sure why the other cases are in Table 7.5-2.
-  switch (numOfCluster) // Table 7.5-2
+  switch (table3gpp->m_numOfCluster) // Table 7.5-2
     {
       case 4:
-        C_NLOS = 0.779;
+        cNlos = 0.779;
         break;
       case 5:
-        C_NLOS = 0.860;
+        cNlos = 0.860;
         break;
       case 8:
-        C_NLOS = 1.018;
+        cNlos = 1.018;
         break;
       case 10:
-        C_NLOS = 1.090;
+        cNlos = 1.090;
         break;
       case 11:
-        C_NLOS = 1.123;
+        cNlos = 1.123;
         break;
       case 12:
-        C_NLOS = 1.146;
+        cNlos = 1.146;
         break;
       case 14:
-        C_NLOS = 1.190;
+        cNlos = 1.190;
         break;
       case 15:
-        C_NLOS = 1.221;
+        cNlos = 1.221;
         break;
       case 16:
-        C_NLOS = 1.226;
+        cNlos = 1.226;
         break;
       case 19:
-        C_NLOS = 1.273;
+        cNlos = 1.273;
         break;
       case 20:
-        C_NLOS = 1.289;
+        cNlos = 1.289;
         break;
       default:
         NS_FATAL_ERROR ("Invalid cluster number");
     }
 
-  if (los)
-    {
-      C_phi = C_NLOS * (1.1035 - 0.028 * K_factor - 2e-3 * pow (K_factor,2) + 1e-4 * pow (K_factor,3));         //(7.5-10))
-    }
-  else
+  double cPhi = cNlos;
+
+  if (channelParams->m_losCondition == ChannelCondition::LOS)
     {
-      C_phi = C_NLOS;  //(7.5-10)
+      cPhi *= (1.1035 - 0.028 * kFactor - 2e-3 * pow (kFactor, 2) + 1e-4 * pow (kFactor, 3)); //(7.5-10))
     }
 
-  double C_theta;
-  switch (numOfCluster) //Table 7.5-4
+  switch (table3gpp->m_numOfCluster) //Table 7.5-4
     {
       case 8:
-        C_NLOS = 0.889;
+        cNlos = 0.889;
         break;
       case 10:
-        C_NLOS = 0.957;
+        cNlos = 0.957;
         break;
       case 11:
-        C_NLOS = 1.031;
+        cNlos = 1.031;
         break;
       case 12:
-        C_NLOS = 1.104;
+        cNlos = 1.104;
         break;
       case 15:
-        C_NLOS = 1.1088;
+        cNlos = 1.1088;
         break;
       case 19:
-        C_NLOS = 1.184;
+        cNlos = 1.184;
         break;
       case 20:
-        C_NLOS = 1.178;
+        cNlos = 1.178;
         break;
       default:
         NS_FATAL_ERROR ("Invalid cluster number");
     }
 
-  if (los)
-    {
-      C_theta = C_NLOS * (1.3086 + 0.0339 * K_factor - 0.0077 * pow (K_factor,2) + 2e-4 * pow (K_factor,3));         //(7.5-15)
-    }
-  else
+  double cTheta = cNlos;
+  if (channelCondition->IsLos())
     {
-      C_theta = C_NLOS;
+      cTheta *= (1.3086 + 0.0339 * kFactor - 0.0077 * pow (kFactor, 2) + 2e-4 * pow (kFactor, 3)); //(7.5-15)
     }
 
-
   DoubleVector clusterAoa, clusterAod, clusterZoa, clusterZod;
-  double angle;
-  for (uint8_t cIndex = 0; cIndex < numReducedCluster; cIndex++)
+  for (uint8_t cIndex = 0; cIndex < channelParams->m_reducedClusterNumber; cIndex++)
     {
-      angle = 2 * ASA * sqrt (-1 * log (clusterPowerForAngles[cIndex] / powerMax)) / 1.4 / C_phi;        //(7.5-9)
-      clusterAoa.push_back (angle);
-      angle = 2 * ASD * sqrt (-1 * log (clusterPowerForAngles[cIndex] / powerMax)) / 1.4 / C_phi;        //(7.5-9)
-      clusterAod.push_back (angle);
-      angle = -1 * ZSA * log (clusterPowerForAngles[cIndex] / powerMax) / C_theta;         //(7.5-14)
-      clusterZoa.push_back (angle);
-      angle = -1 * ZSD * log (clusterPowerForAngles[cIndex] / powerMax) / C_theta;
-      clusterZod.push_back (angle);
+      double logCalc = -1 * log (clusterPowerForAngles[cIndex] / powerMax);
+      double angle = 2 * sqrt (logCalc) / 1.4 / cPhi; //(7.5-9)
+      clusterAoa.push_back (ASA * angle);
+      clusterAod.push_back (ASD * angle);
+      angle = logCalc / cTheta; //(7.5-14)
+      clusterZoa.push_back (ZSA * angle);
+      clusterZod.push_back (ZSD * angle);
     }
 
-  for (uint8_t cIndex = 0; cIndex < numReducedCluster; cIndex++)
+  Angles sAngle (bMob->GetPosition (), aMob->GetPosition ());
+  Angles uAngle (aMob->GetPosition (), bMob->GetPosition ());
+
+  for (uint8_t cIndex = 0; cIndex < channelParams->m_reducedClusterNumber; cIndex++)
     {
       int Xn = 1;
-      if (m_uniformRv->GetValue (0,1) < 0.5)
+      if (m_uniformRv->GetValue (0, 1) < 0.5)
         {
           Xn = -1;
         }
       clusterAoa[cIndex] = clusterAoa[cIndex] * Xn + (m_normalRv->GetValue () * ASA / 7) + RadiansToDegrees (uAngle.GetAzimuth ());        //(7.5-11)
       clusterAod[cIndex] = clusterAod[cIndex] * Xn + (m_normalRv->GetValue () * ASD / 7) + RadiansToDegrees (sAngle.GetAzimuth ());
-      if (o2i)
+      if (channelCondition->IsO2i ())
         {
           clusterZoa[cIndex] = clusterZoa[cIndex] * Xn + (m_normalRv->GetValue () * ZSA / 7) + 90;            //(7.5-16)
         }
@@ -1348,140 +1479,147 @@
           clusterZoa[cIndex] = clusterZoa[cIndex] * Xn + (m_normalRv->GetValue () * ZSA / 7) + RadiansToDegrees (uAngle.GetInclination ());            //(7.5-16)
         }
       clusterZod[cIndex] = clusterZod[cIndex] * Xn + (m_normalRv->GetValue () * ZSD / 7) + RadiansToDegrees (sAngle.GetInclination ()) + table3gpp->m_offsetZOD;        //(7.5-19)
-
     }
 
-  if (los)
+  if (channelParams->m_losCondition == ChannelCondition::LOS)
     {
-      //The 7.5-12 can be rewrite as Theta_n,ZOA = Theta_n,ZOA - (Theta_1,ZOA - Theta_LOS,ZOA) = Theta_n,ZOA - diffZOA,
-      //Similar as AOD, ZSA and ZSD.
+      // The 7.5-12 can be rewrite as Theta_n,ZOA = Theta_n,ZOA - (Theta_1,ZOA - Theta_LOS,ZOA) = Theta_n,ZOA - diffZOA,
+      // Similar as AOD, ZSA and ZSD.
       double diffAoa = clusterAoa[0] - RadiansToDegrees (uAngle.GetAzimuth ());
       double diffAod = clusterAod[0] - RadiansToDegrees (sAngle.GetAzimuth ());
       double diffZsa = clusterZoa[0] - RadiansToDegrees (uAngle.GetInclination ());
       double diffZsd = clusterZod[0] - RadiansToDegrees (sAngle.GetInclination ());
 
-      for (uint8_t cIndex = 0; cIndex < numReducedCluster; cIndex++)
+      for (uint8_t cIndex = 0; cIndex < channelParams->m_reducedClusterNumber; cIndex++)
         {
           clusterAoa[cIndex] -= diffAoa; //(7.5-12)
           clusterAod[cIndex] -= diffAod;
           clusterZoa[cIndex] -= diffZsa; //(7.5-17)
           clusterZod[cIndex] -= diffZsd;
-
         }
     }
 
-  double rayAoa_radian[numReducedCluster][raysPerCluster]; //rayAoa_radian[n][m], where n is cluster index, m is ray index
-  double rayAod_radian[numReducedCluster][raysPerCluster]; //rayAod_radian[n][m], where n is cluster index, m is ray index
-  double rayZoa_radian[numReducedCluster][raysPerCluster]; //rayZoa_radian[n][m], where n is cluster index, m is ray index
-  double rayZod_radian[numReducedCluster][raysPerCluster]; //rayZod_radian[n][m], where n is cluster index, m is ray index
-
-  for (uint8_t nInd = 0; nInd < numReducedCluster; nInd++)
-    {
-      for (uint8_t mInd = 0; mInd < raysPerCluster; mInd++)
-        {
-          double tempAoa = clusterAoa[nInd] + table3gpp->m_cASA * offSetAlpha[mInd]; //(7.5-13)
-          double tempZoa = clusterZoa[nInd] + table3gpp->m_cZSA * offSetAlpha[mInd]; //(7.5-18)
-          std::tie (rayAoa_radian[nInd][mInd], rayZoa_radian[nInd][mInd]) = WrapAngles (DegreesToRadians (tempAoa), DegreesToRadians (tempZoa));
-
-          double tempAod = clusterAod[nInd] + table3gpp->m_cASD * offSetAlpha[mInd]; //(7.5-13)
-          double tempZod = clusterZod[nInd] + 0.375 * pow (10,table3gpp->m_uLgZSD) * offSetAlpha[mInd]; //(7.5-20)
-          std::tie (rayAod_radian[nInd][mInd], rayZod_radian[nInd][mInd]) = WrapAngles (DegreesToRadians (tempAod), DegreesToRadians (tempZod));
-        }
-    }
-  DoubleVector angle_degree;
   double sizeTemp = clusterZoa.size ();
   for (uint8_t ind = 0; ind < 4; ind++)
     {
+      DoubleVector angleDegree;
       switch (ind)
         {
           case 0:
-            angle_degree = clusterAoa;
+            angleDegree = clusterAoa;
             break;
           case 1:
-            angle_degree = clusterZoa;
+            angleDegree = clusterZoa;
             break;
           case 2:
-            angle_degree = clusterAod;
+            angleDegree = clusterAod;
             break;
           case 3:
-            angle_degree = clusterZod;
+            angleDegree = clusterZod;
             break;
           default:
             NS_FATAL_ERROR ("Programming Error");
         }
-
       for (uint8_t nIndex = 0; nIndex < sizeTemp; nIndex++)
         {
-          while (angle_degree[nIndex] > 360)
+          while (angleDegree[nIndex] > 360)
             {
-              angle_degree[nIndex] -= 360;
+              angleDegree[nIndex] -= 360;
             }
 
-          while (angle_degree[nIndex] < 0)
+          while (angleDegree[nIndex] < 0)
             {
-              angle_degree[nIndex] += 360;
+              angleDegree[nIndex] += 360;
             }
 
           if (ind == 1 || ind == 3)
             {
-              if (angle_degree[nIndex] > 180)
+              if (angleDegree[nIndex] > 180)
                 {
-                  angle_degree[nIndex] = 360 - angle_degree[nIndex];
+                  angleDegree[nIndex] = 360 - angleDegree[nIndex];
                 }
             }
         }
       switch (ind)
         {
           case 0:
-            clusterAoa = angle_degree;
+            clusterAoa = angleDegree;
             break;
           case 1:
-            clusterZoa = angle_degree;
+            clusterZoa = angleDegree;
             break;
           case 2:
-            clusterAod = angle_degree;
+            clusterAod = angleDegree;
             break;
           case 3:
-            clusterZod = angle_degree;
+            clusterZod = angleDegree;
             break;
           default:
             NS_FATAL_ERROR ("Programming Error");
         }
     }
 
-  DoubleVector attenuation_dB;
+  DoubleVector attenuationDb;
   if (m_blockage)
     {
-      attenuation_dB = CalcAttenuationOfBlockage (channelParams, clusterAoa, clusterZoa);
-      for (uint8_t cInd = 0; cInd < numReducedCluster; cInd++)
+      attenuationDb = CalcAttenuationOfBlockage (channelParams, clusterAoa, clusterZoa);
+      for (uint8_t cInd = 0; cInd < channelParams->m_reducedClusterNumber; cInd++)
         {
-          clusterPower[cInd] = clusterPower[cInd] / pow (10,attenuation_dB[cInd] / 10);
+          channelParams->m_clusterPower[cInd] = channelParams->m_clusterPower[cInd] / pow (10,attenuationDb[cInd] / 10);
         }
     }
   else
     {
-      attenuation_dB.push_back (0);
+      attenuationDb.push_back (0);
     }
 
+  // store attenuation
+  channelParams->m_attenuation_dB = attenuationDb;
+
   //Step 8: Coupling of rays within a cluster for both azimuth and elevation
   //shuffle all the arrays to perform random coupling
-  for (uint8_t cIndex = 0; cIndex < numReducedCluster; cIndex++)
+  MatrixBasedChannelModel::Double2DVector rayAoaRadian (channelParams->m_reducedClusterNumber, DoubleVector (table3gpp->m_raysPerCluster, 0)); //rayAoaRadian[n][m], where n is cluster index, m is ray index
+  MatrixBasedChannelModel::Double2DVector rayAodRadian (channelParams->m_reducedClusterNumber, DoubleVector (table3gpp->m_raysPerCluster, 0)); //rayAodRadian[n][m], where n is cluster index, m is ray index
+  MatrixBasedChannelModel::Double2DVector rayZoaRadian (channelParams->m_reducedClusterNumber, DoubleVector (table3gpp->m_raysPerCluster, 0)); //rayZoaRadian[n][m], where n is cluster index, m is ray index
+  MatrixBasedChannelModel::Double2DVector rayZodRadian (channelParams->m_reducedClusterNumber, DoubleVector (table3gpp->m_raysPerCluster, 0)); //rayZodRadian[n][m], where n is cluster index, m is ray index
+
+  for (uint8_t nInd = 0; nInd < channelParams->m_reducedClusterNumber; nInd++)
+    {
+      for (uint8_t mInd = 0; mInd < table3gpp->m_raysPerCluster; mInd++)
+        {
+          double tempAoa = clusterAoa[nInd] + table3gpp->m_cASA * offSetAlpha[mInd]; //(7.5-13)
+          double tempZoa = clusterZoa[nInd] + table3gpp->m_cZSA * offSetAlpha[mInd]; //(7.5-18)
+          std::tie (rayAoaRadian[nInd][mInd], rayZoaRadian[nInd][mInd]) = WrapAngles (DegreesToRadians (tempAoa), DegreesToRadians (tempZoa));
+
+          double tempAod = clusterAod[nInd] + table3gpp->m_cASD * offSetAlpha[mInd]; //(7.5-13)
+          double tempZod = clusterZod[nInd] + 0.375 * pow (10,table3gpp->m_uLgZSD) * offSetAlpha[mInd]; //(7.5-20)
+          std::tie (rayAodRadian[nInd][mInd], rayZodRadian[nInd][mInd]) = WrapAngles (DegreesToRadians (tempAod), DegreesToRadians (tempZod));
+        }
+    }
+
+  for (uint8_t cIndex = 0; cIndex < channelParams->m_reducedClusterNumber; cIndex++)
     {
-      Shuffle (&rayAod_radian[cIndex][0], &rayAod_radian[cIndex][raysPerCluster]);
-      Shuffle (&rayAoa_radian[cIndex][0], &rayAoa_radian[cIndex][raysPerCluster]);
-      Shuffle (&rayZod_radian[cIndex][0], &rayZod_radian[cIndex][raysPerCluster]);
-      Shuffle (&rayZoa_radian[cIndex][0], &rayZoa_radian[cIndex][raysPerCluster]);
+      Shuffle (&rayAodRadian[cIndex][0], &rayAodRadian[cIndex][table3gpp->m_raysPerCluster]);
+      Shuffle (&rayAoaRadian[cIndex][0], &rayAoaRadian[cIndex][table3gpp->m_raysPerCluster]);
+      Shuffle (&rayZodRadian[cIndex][0], &rayZodRadian[cIndex][table3gpp->m_raysPerCluster]);
+      Shuffle (&rayZoaRadian[cIndex][0], &rayZoaRadian[cIndex][table3gpp->m_raysPerCluster]);
     }
 
+  // store values
+  channelParams->m_rayAodRadian = rayAodRadian;
+  channelParams->m_rayAoaRadian = rayAoaRadian;
+  channelParams->m_rayZodRadian = rayZodRadian;
+  channelParams->m_rayZoaRadian = rayZoaRadian;
+
   //Step 9: Generate the cross polarization power ratios
   //Step 10: Draw initial phases
   Double2DVector crossPolarizationPowerRatios; // vector containing the cross polarization power ratios, as defined by 7.5-21
-  Double3DVector clusterPhase; //rayAoa_radian[n][m], where n is cluster index, m is ray index
-  for (uint8_t nInd = 0; nInd < numReducedCluster; nInd++)
+  Double3DVector clusterPhase; //rayAoaRadian[n][m], where n is cluster index, m is ray index
+  for (uint8_t nInd = 0; nInd < channelParams->m_reducedClusterNumber; nInd++)
     {
       DoubleVector temp; // used to store the XPR values
       Double2DVector temp2; // used to store the PHI values for all the possible combination of polarization
-      for (uint8_t mInd = 0; mInd < raysPerCluster; mInd++)
+      for (uint8_t mInd = 0; mInd < table3gpp->m_raysPerCluster; mInd++)
         {
           double uXprLinear = pow (10, table3gpp->m_uXpr / 10); // convert to linear
           double sigXprLinear = pow (10, table3gpp->m_sigXpr / 10); // convert to linear
@@ -1497,52 +1635,228 @@
       crossPolarizationPowerRatios.push_back (temp);
       clusterPhase.push_back (temp2);
     }
+  // store the cluster phase
   channelParams->m_clusterPhase = clusterPhase;
-
-  //Step 11: Generate channel coefficients for each cluster n and each receiver
-  // and transmitter element pair u,s.
-
-  Complex3DVector H_NLOS; // channel coefficients H_NLOS [u][s][n],
-  // where u and s are receive and transmit antenna element, n is cluster index.
-  uint64_t uSize = uAntenna->GetNumberOfElements ();
-  uint64_t sSize = sAntenna->GetNumberOfElements ();
+  channelParams->m_crossPolarizationPowerRatios = crossPolarizationPowerRatios;
 
   uint8_t cluster1st = 0, cluster2nd = 0; // first and second strongest cluster;
   double maxPower = 0;
-  for (uint8_t cIndex = 0; cIndex < numReducedCluster; cIndex++)
+  for (uint8_t cIndex = 0; cIndex < channelParams->m_reducedClusterNumber; cIndex++)
     {
-      if (maxPower < clusterPower[cIndex])
+      if (maxPower < channelParams->m_clusterPower[cIndex])
         {
-          maxPower = clusterPower[cIndex];
+          maxPower = channelParams->m_clusterPower[cIndex];
           cluster1st = cIndex;
         }
     }
+  channelParams->m_cluster1st = cluster1st;
   maxPower = 0;
-  for (uint8_t cIndex = 0; cIndex < numReducedCluster; cIndex++)
+  for (uint8_t cIndex = 0; cIndex < channelParams->m_reducedClusterNumber; cIndex++)
     {
-      if (maxPower < clusterPower[cIndex] && cluster1st != cIndex)
+      if (maxPower < channelParams->m_clusterPower[cIndex] && cluster1st != cIndex)
         {
-          maxPower = clusterPower[cIndex];
+          maxPower = channelParams->m_clusterPower[cIndex];
           cluster2nd = cIndex;
         }
     }
+  channelParams->m_cluster2nd = cluster2nd;
 
-  NS_LOG_INFO ("1st strongest cluster:" << (int)cluster1st << ", 2nd strongest cluster:" << (int)cluster2nd);
+  NS_LOG_INFO ("1st strongest cluster:" << +cluster1st
+                                        << ", 2nd strongest cluster:" << +cluster2nd);
+
+  // store the delays and the angles for the subclusters
+  if (cluster1st == cluster2nd)
+    {
+      clusterDelay.push_back (clusterDelay[cluster1st] + 1.28 * table3gpp->m_cDS);
+      clusterDelay.push_back (clusterDelay[cluster1st] + 2.56 * table3gpp->m_cDS);
 
-  Complex3DVector H_usn;  //channel coffecient H_usn[u][s][n];
+      clusterAoa.push_back (clusterAoa[cluster1st]);
+      clusterAoa.push_back (clusterAoa[cluster1st]);
+
+      clusterZoa.push_back (clusterZoa[cluster1st]);
+      clusterZoa.push_back (clusterZoa[cluster1st]);
+
+      clusterAod.push_back (clusterAod[cluster1st]);
+      clusterAod.push_back (clusterAod[cluster1st]);
+
+      clusterZod.push_back (clusterZod[cluster1st]);
+      clusterZod.push_back (clusterZod[cluster1st]);
+    }
+  else
+    {
+      double min, max;
+      if (cluster1st < cluster2nd)
+        {
+          min = cluster1st;
+          max = cluster2nd;
+        }
+      else
+        {
+          min = cluster2nd;
+          max = cluster1st;
+        }
+      clusterDelay.push_back (clusterDelay[min] + 1.28 * table3gpp->m_cDS);
+      clusterDelay.push_back (clusterDelay[min] + 2.56 * table3gpp->m_cDS);
+      clusterDelay.push_back (clusterDelay[max] + 1.28 * table3gpp->m_cDS);
+      clusterDelay.push_back (clusterDelay[max] + 2.56 * table3gpp->m_cDS);
+
+      clusterAoa.push_back (clusterAoa[min]);
+      clusterAoa.push_back (clusterAoa[min]);
+      clusterAoa.push_back (clusterAoa[max]);
+      clusterAoa.push_back (clusterAoa[max]);
+
+      clusterZoa.push_back (clusterZoa[min]);
+      clusterZoa.push_back (clusterZoa[min]);
+      clusterZoa.push_back (clusterZoa[max]);
+      clusterZoa.push_back (clusterZoa[max]);
+
+      clusterAod.push_back (clusterAod[min]);
+      clusterAod.push_back (clusterAod[min]);
+      clusterAod.push_back (clusterAod[max]);
+      clusterAod.push_back (clusterAod[max]);
+
+      clusterZod.push_back (clusterZod[min]);
+      clusterZod.push_back (clusterZod[min]);
+      clusterZod.push_back (clusterZod[max]);
+      clusterZod.push_back (clusterZod[max]);
+
+
+    }
+
+  channelParams->m_delay = clusterDelay;
+  channelParams->m_angle.clear ();
+  channelParams->m_angle.push_back (clusterAoa);
+  channelParams->m_angle.push_back (clusterZoa);
+  channelParams->m_angle.push_back (clusterAod);
+  channelParams->m_angle.push_back (clusterZod);
+
+  // Compute alpha and D as described in 3GPP TR 37.885 v15.3.0, Sec. 6.2.3
+  // These terms account for an additional Doppler contribution due to the
+  // presence of moving objects in the surrounding environment, such as in
+  // vehicular scenarios.
+  // This contribution is applied only to the delayed (reflected) paths and
+  // must be properly configured by setting the value of
+  // m_vScatt, which is defined as "maximum speed of the vehicle in the
+  // layout".
+  // By default, m_vScatt is set to 0, so there is no additional Doppler
+  // contribution.
+
+  DoubleVector dopplerTermAlpha, dopplerTermD;
+
+  // 2 or 4 is added to account for additional subrays for the 1st and 2nd clusters, if there is only one cluster then would be added 2 more subrays (see creation of Husn channel matrix)
+  uint8_t updatedClusterNumber = (channelParams->m_reducedClusterNumber == 1) ? channelParams->m_reducedClusterNumber + 2 : channelParams->m_reducedClusterNumber + 4;
+
+  for (uint8_t cIndex = 0; cIndex < updatedClusterNumber ; cIndex++)
+    {
+      double alpha = 0;
+      double D = 0;
+      if (cIndex != 0)
+      {
+        alpha = m_uniformRvDoppler->GetValue (-1, 1);
+        D = m_uniformRvDoppler->GetValue (-m_vScatt, m_vScatt);
+      }
+      dopplerTermAlpha.push_back (alpha);
+      dopplerTermD.push_back (D);
+    }
+  channelParams->m_alpha = dopplerTermAlpha;
+  channelParams->m_D = dopplerTermD;
+
+  return channelParams;
+}
+
+Ptr<MatrixBasedChannelModel::ChannelMatrix>
+ThreeGppChannelModel::GetNewChannel (Ptr<const ThreeGppChannelParams> channelParams,
+                                     Ptr<const ParamsTable> table3gpp,
+                                     const Ptr<const MobilityModel> sMob,
+                                     const Ptr<const MobilityModel> uMob,
+                                     Ptr<const PhasedArrayModel> sAntenna,
+                                     Ptr<const PhasedArrayModel> uAntenna
+                                     ) const
+{
+  NS_LOG_FUNCTION (this);
+
+  NS_ASSERT_MSG (m_frequency > 0.0, "Set the operating frequency first!");
+
+  // create a channel matrix instance
+  Ptr<ChannelMatrix> channelMatrix = Create<ChannelMatrix> ();
+  channelMatrix->m_generatedTime = Simulator::Now ();
+  // save in which order is generated this matrix
+  channelMatrix->m_nodeIds = std::make_pair (sMob->GetObject<Node> ()->GetId (), uMob->GetObject<Node> ()->GetId ());
+  // check if channelParams structure is generated in direction s-to-u or u-to-s
+  bool isSameDirection = (channelParams->m_nodeIds == channelMatrix->m_nodeIds);
+
+  MatrixBasedChannelModel::Double2DVector rayAodRadian;
+  MatrixBasedChannelModel::Double2DVector rayAoaRadian;
+  MatrixBasedChannelModel::Double2DVector rayZodRadian;
+  MatrixBasedChannelModel::Double2DVector rayZoaRadian;
+
+  // if channel params is generated in the same direction in which we
+  // generate the channel matrix, angles and zenit od departure and arrival are ok,
+  // just set them to corresponding variable that will be used for the generation
+  // of channel matrix, otherwise we need to flip angles and zenits of departure and arrival
+  if (isSameDirection)
+    {
+      rayAodRadian = channelParams->m_rayAodRadian;
+      rayAoaRadian = channelParams->m_rayAoaRadian;
+      rayZodRadian = channelParams->m_rayZodRadian;
+      rayZoaRadian = channelParams->m_rayZoaRadian;
+    }
+  else
+    {
+      rayAodRadian = channelParams->m_rayAoaRadian;
+      rayAoaRadian = channelParams->m_rayAodRadian;
+      rayZodRadian = channelParams->m_rayZoaRadian;
+      rayZoaRadian = channelParams->m_rayZodRadian;
+    }
+
+  //Step 11: Generate channel coefficients for each cluster n and each receiver
+  // and transmitter element pair u,s.
+  Complex3DVector hUsn;  //channel coffecient hUsn[u][s][n];
+  // where u and s are receive and transmit antenna element, n is cluster index.
   // NOTE Since each of the strongest 2 clusters are divided into 3 sub-clusters,
   // the total cluster will be numReducedCLuster + 4.
+  uint64_t uSize = uAntenna->GetNumberOfElements ();
+  uint64_t sSize = sAntenna->GetNumberOfElements ();
 
-  H_usn.resize (uSize);
+  hUsn.resize (uSize);
   for (uint64_t uIndex = 0; uIndex < uSize; uIndex++)
     {
-      H_usn[uIndex].resize (sSize);
+      hUsn[uIndex].resize (sSize);
       for (uint64_t sIndex = 0; sIndex < sSize; sIndex++)
         {
-          H_usn[uIndex][sIndex].resize (numReducedCluster);
+          hUsn[uIndex][sIndex].resize (channelParams->m_reducedClusterNumber);
         }
     }
 
+  NS_ASSERT (channelParams->m_reducedClusterNumber <= channelParams->m_clusterPhase.size ());
+  NS_ASSERT (channelParams->m_reducedClusterNumber <= channelParams->m_clusterPower.size ());
+  NS_ASSERT (channelParams->m_reducedClusterNumber <= channelParams->m_crossPolarizationPowerRatios.size ());
+  NS_ASSERT (channelParams->m_reducedClusterNumber <= rayZoaRadian.size ());
+  NS_ASSERT (channelParams->m_reducedClusterNumber <= rayZodRadian.size ());
+  NS_ASSERT (channelParams->m_reducedClusterNumber <= rayAoaRadian.size ());
+  NS_ASSERT (channelParams->m_reducedClusterNumber <= rayAodRadian.size ());
+  NS_ASSERT (table3gpp->m_raysPerCluster <= channelParams->m_clusterPhase[0].size ());
+  NS_ASSERT (table3gpp->m_raysPerCluster <= channelParams->m_crossPolarizationPowerRatios[0].size ());
+  NS_ASSERT (table3gpp->m_raysPerCluster <= rayZoaRadian[0].size ());
+  NS_ASSERT (table3gpp->m_raysPerCluster <= rayZodRadian[0].size ());
+  NS_ASSERT (table3gpp->m_raysPerCluster <= rayAoaRadian[0].size ());
+  NS_ASSERT (table3gpp->m_raysPerCluster <= rayAodRadian[0].size ());
+
+
+  double x = sMob->GetPosition ().x - uMob->GetPosition ().x;
+  double y = sMob->GetPosition ().y - uMob->GetPosition ().y;
+  double distance2D = sqrt (x * x + y * y);
+  // NOTE we assume hUT = min (height(a), height(b)) and
+  // hBS = max (height (a), height (b))
+  double hUt = std::min (sMob->GetPosition ().z, uMob->GetPosition ().z);
+  double hBs = std::max (sMob->GetPosition ().z, uMob->GetPosition ().z);
+  // compute the 3D distance using eq. 7.4-1
+  double distance3D = std::sqrt (distance2D * distance2D + (hBs - hUt) * (hBs - hUt));
+
+  Angles sAngle (uMob->GetPosition (), sMob->GetPosition ());
+  Angles uAngle (sMob->GetPosition (), uMob->GetPosition ());
+
+
   // The following for loops computes the channel coefficients
   for (uint64_t uIndex = 0; uIndex < uSize; uIndex++)
     {
